var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField, MapToComponentMethod, VegaSlimmer } from 'vega-slimmer/core';
/**
 * Controller class for managing the file upload limit in the Vega file uploader component.
 */
export class VegaFileUploaderFileLimitController extends VegaSlimmer {
  /**
   * Determines if the file uploader is in single mode.
   *
   * @returns {boolean} `true` if the maximum file count is 1, otherwise `false`.
   */
  isSingleMode() {
    return Number(this.maxCount) === 1;
  }
  /**
   * Checks if the `maxCount` property is valid. If `maxCount` is less than 1 and not `null`, it will be set to `null`.
   */
  checkMaxCount() {
    if (this.maxCount !== null && this.maxCount < 1) {
      this.maxCount = null;
    }
  }
}
__decorate([
  MapToComponentField({ writable: true })
], VegaFileUploaderFileLimitController.prototype, "maxCount", void 0);
__decorate([
  MapToComponentMethod('componentDidLoad'),
  MapToComponentMethod('watchMaxCount')
], VegaFileUploaderFileLimitController.prototype, "checkMaxCount", null);
